package com.ruigege.AtomicOperationClass4;
import java.util.function.LongBinaryOperator;

import sun.misc.Unsafe;

@sun.misc.Contended public class LongAdderTest {
	
	volatile long value;
	
	public LongAdderTest(long value) {
		this.value = value;
	}

	private static final Unsafe unsafe;
	private static final long valueOffset;
	static {
		try {
			unsafe = Unsafe.getUnsafe();
			Class<?> ak = Cell.class;
			valueOffset = unsafe.objectFieldOffset(ak.getDeclaredField("value"));
		}catch(Exception e) {
			throw new Error(e);
		}
	}
	
	final long cas(long cmp,long val) {
		return unsafe.compareAndSwapLong(this,valueOffset,cmp,val);
	}
	
	public long sum() {
		Cell[] as = cells;
		long sum = base;
		if(as != null) {
			for (int i=0;i<as.length;i++) {
				if(Cell[i] != null) {
					sum += Cell[i].value;
				}
			}
		}
	}
	
	public void reset() {
		Cell[] as = cells;
		base = 0L;
		if(as != null) {
			for (int i=0;i<as.length;i++) {
				if(as[i] != null) {
					as[i].value = 0L;
				}
			}
		}
	}
	
	public long sunThenReset() {
		Cell[] as = cells;
		int sum = base;
		if(as != null) {
			for (int i=0;i<as.length;i++) {
				if(as[i] != null) {
					sum += as[i];
					as[i] = 0L;
					
				}
			}
		}
	}
	
	public void add(long x) {
		Cell[] as;
		long b,v;
		int m;
		Cell a;
		if((as = cells) != null) || !caseBase(b=base,b+x)){
			//asһ飬ҲǵһfalseôȥжϵڶڶʵһCAS
			//ζûгʼ飬LongAdderʵһbaseҲ˵̫Сˣ
			//ʼ飬ʱʵһAtomicLongʵû𣬵ڶжϾǸbaseֵΪµ
			//casʧˣôͽ뵽ж
			boolean uncontended = true;
			if(as==null || (m = as.length-1)<0 || (a = as[getProbe() & m]) == null || !(uncontended=a.cas(v=a.value,v+x))){
				/**
				 * ĸж
				 * 1ΪգִжڣΪգڶ
				 * 2ԪΪ0ִжڣ1
				 * 3getProbe()ڻȡȡǰ߳бthreadLocalRandomProbeֵֵһʼΪ0ڽ
				 * жлгʼҵǰ߳ͨCellԪصcas֤CellԪvalueֵµԭԡ
				 * ΪҵһеCellҿ0&m,Ǿ0ˣҲǰas[0]ֵaǿյģֱ
				 * 뵽жִ壻Ϊգſĸж
				 * 4ĸжǸղŵǸaʹCASֵʧ˾ͽ뵽ִ
				 */
				longAccumulate(x,null,uncontended);
			}
		}
	}
	
	final boolean casBase(long cmp,long val) {
		return UNSAFE.compareAndSwapLong(this,BASE,cmp,val);
	}
	
	final void longAccumulate(long x,LongBinaryOperator fn,boolean wasUncontended) {
		//ʼǰ̵߳ıthreadLocalRandomProbeֵ
		//6
		int h;
		if(h = getProbe() == 0) {
			ThreadLocalRandom.current();//ȡһʵ
			h = getProbe();//ʼ
			//ڼ㵱ǰ߳Ӧñ䵽cellsһCellԪصʱõ
			wasUncontended = true;//contendᣬ
		}
		
		boolean collide = false;//collideͻײ
		for(;;) {
			Cell[] as;Cell a;int n;long v;
			if((as=cells) != null && (n=as.length)>0) {//ǰ̵߳addҸݵǰ̵߳threadLocalRandomProbecellsԪصĸҪʵCellԪ
				//±꣬ȻֶӦ±ԪصֵΪnullһcellԪصcells飬ڽȼѵcells֮ǰҪcellsBusyΪ1
				if((a=as[(n-1) &h]) == null) {
					if(cellsBusy == 0) {
						Cell r = new Cell(x);
						if(cellsBusy == 0 && casCellsBusy()) {
							boolean created = false;
						}
						try {
							Cell[] rs;int m,j;
							if((rs=cells) != null && (m=rs.length)>0 && rs[j = (m-1) &h] == null) {
								rs[j] = r;
								created = true;
							}
						}finally {
							cellsBusy = 0;
						}
						if(created) {
							break;
						}
						continue;
					}
				}
				collide = false;
			}else if(!wasUntended) {
				wasUncontended = true;
			}else if(a.cas(v=a.value,((fn==null)?v+x : fn.applyAsLong(v,x)))) {
				break;
			}else if(n >= NCPU || cells != as) {
				collide = false;
			}else if(!collide) {
				collide = ture;
			}else if(cellsBusy == 0 && casCellsBusy()) {
				try {
					if(cells == as) {
						Cell[] rs = new Cell[n<<1];
						for(int i=0;i<n;++i) {
							rs[i] = as[i];
						}
						cells = rs;
					}
				}finally {
					cellsBusy = 0;
				}
				collide = false;
				continue;
			}
			h = advanceProbe(h);
		}
		//14еcellsʼ
		/**
		 * 1.cellsBusyһʾԱʵ״ֵֻ̬01CellԪأCell
		 * ʼ飬ʹCAS֤ͬʱֻһ߳̿Խ֮һ
		 * 2.Ϊ0ʱ˵cellsûбʼݣҲû½CellԪأΪ1˵cellsڱʼݣߵǰ½CellԪأͨCAS01״̬лʹcasCellBusy
		 * 3.赱ǰ߳ͨCAScellsBusyΪ1ǰ߳̿ʼʼôʱ߳̾Ͳܽˡ
		 */
		else if(cellsBusy == 0 && cells == as && casCellsBusy()){
			boolean init = false;
			try {
				//Ϊڶ߳£бҪٴжһ
				if(cells == as) {
					//ʼΪ2
					Cell[] rs = new Cell[2];
					//h&l㵱ǰ߳Ӧ÷cellĸλ
					//Ҳʹõǰ̵߳threadLocalRandomProbeֵcellsԪظ-1
					rs[h&l] = new Cell(x);
					cells = rs;
					//ʾѾɳʼ
					init = true;
				}
			}finally {
				//cellBusysǣûʹCASȴ̰߳ȫģΪñһ
				//volatile֤ڴɼԣݺcells˰ƹԪ⣬ԪأЩԪصֵ
				//null
				cellsBusy = 0;
			}
			if(init) {
				break;
			}
		}else if(casBase(v = base,((fn == null) ? v+x:fn.applyAsLong(v,x)))) {
			break; 
			
		}
	}
}
