package com.ruigege.ConcurrentListSouceCodeAnalysis5;

import java.util.Arrays;
import java.util.Collection;
import java.util.List;
import java.util.RandomAccess;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.concurrent.locks.ReentrantLock;

public class CopyOnWriteArrayListAnalysis<E> implements List<E>,RandomAccess, Cloneable, java.io.Serializable {
	
	CopyWriteArrayList a = new CopyOnWriteArrayList();
	
    private transient volatile Object[] array;

	public CopyOnWriteArrayListAnalysis() {
		setArray(new Object[0]);
	}
	
    final void setArray(Object[] a) {
        array = a;
    }
    
    public CopyOnWriteArrayListAnalysis(E[] toCopyIn) {
    	//ߺArrays.copyOfʾһڶĳȣΪһ飬ҷصǵ
    	setArray(Arrays.copyOf(toCopyIn, toCopyIn.length,Object[].class));
    }
    
    public CopyOnWriteArrayListAnalysis(Collection<? extends E> c) {
    	Object[] elements;
    	if(c.getClass() == CopyOnWriteArrayListAnalysis.class) {
    		elements = ((CopyOnWriteArrayListAnanlysis)c).getArray();
    	}else {
    		elements = c.toArray();
    		//жûзһObject[].class
    		if(elements.getClass() != Object[].class) {
    			elements = Arrays.copyOf(elements,elements.length,Object[].class);
    		}
    	}
    }
    
    
    final Object[] getArray() {
        return array;
    }
    
    public boolean add(E element) {
    	final ReentrantLock lock = this.lock; // ȡʵĶռ
    	lock.lock();
    	try {
    		Object[] elements = getArray(); // ȡڲ洢飬עʱԭ飬
    		// ֻʹһµָĵַ
    		int len = elements.length; // ȡĳ
    		Object[] newElements = Arrays.copyOf(elements,len+1);
    		// ʹArrays࣬һµ飬ǰԪȫƽȥһλ
    		newElements[len] = element;
    		// ʹԭ
    		setArray(newElements);
    	}finally {
    		lock.unlock();
    	}
    }
    
    public E get(int index) {
    	return get(getArray(),index);
    }
    
    public E get(Object[] a,int index) {
    	return (E)a[index];
    }
    
    public E set(int index ,E element) {
    	final ReentrantLock lock = this.lock;
    	lock.lock();
    	try {
    		Object[] a = getArray();
    		E oldValue = a[index];
    		if(oldValue != element) {
    			int len = a.length;
    			Object[] newElements = Arrays.copyOf(a, len);
    			newElements[index] = element;
    			setArray(newElements);
    		}else {
    			setArray(a);
    		}
    		
    	}finally{
    		lock.unlock();
    	}
    }
    
    public E remove(int index) {
    	final ReentrantLock lock = this.lock;
    	lock.lock();
    	try {
    		Object[] elements = getArray();
    		int len = elements.length;
    		int removeRemain = len - (index + 1); // ҪǨƵʣԪظ
    		if(removeRemain == 0) {
    			setArray(Arrays.copyOf(elements, len-1));//һȫcopyȥ
    		}else {
    			Object[] newElements = new Object[len-1];
    			System.arraycopy(elements,0,newElements,0,index);
    			System.arraycopy(elements,index+1,newElements,index,removeRemain);
    			// ѧϰһSystem.arraycopy
    			// һ︴ƣڶӵڼʼ
    			// ƵĸУӵڼʼƼ
    			setArray(newElements);
    		}
    	}finally {
    		lock.unlock();
    	}
    }
    
    public Iterator<E> iterator(){
    	return new COWIteratro<E>(getArray(),0);
    }
    
    static final class COWIterator<E> implements ListIterator<E> {
    	// arrayĿհ汾
    	private final Object[] snapshot;
    	
    	private int cursor;
    	
    	private COWIterator(Object[] elements,int initialCursor) {
    		cursor = initialCursor;
    		snapshot = elements;
    	}
    	
    	
    	public boolean hasNext() {
    		return cursor < snapshot.length;
    	}
    	
    	public E next() {
    		if(!hasNext()) {
    			throw new NoSuchElementException();
    		}
    		return <E>snapshot[cursor++];
    	}	
    }    
}
